package com.sun.nio.sctp;

import java.nio.ByteBuffer;
import java.net.InetAddress;
import java.net.SocketAddress;
import java.util.Set;
import java.io.IOException;
import sun.nio.ch.sctp.SctpMultiChannelImpl;
import java.nio.channels.spi.SelectorProvider;
import jdk.Exported;
import java.nio.channels.spi.AbstractSelectableChannel;

@Exported
public abstract class SctpMultiChannel extends AbstractSelectableChannel
{
    protected SctpMultiChannel(SelectorProvider provider) {
        super(provider);
    }
    
    public static SctpMultiChannel open() throws IOException {
        return new SctpMultiChannelImpl((SelectorProvider)null);
    }
    
    public abstract Set<Association> associations() throws IOException;
    
    public abstract SctpMultiChannel bind(SocketAddress p0, int p1) throws IOException;
    
    public final SctpMultiChannel bind(SocketAddress socketAddress) throws IOException {
        return this.bind(socketAddress, 0);
    }
    
    public abstract SctpMultiChannel bindAddress(InetAddress p0) throws IOException;
    
    public abstract SctpMultiChannel unbindAddress(InetAddress p0) throws IOException;
    
    public abstract Set<SocketAddress> getAllLocalAddresses() throws IOException;
    
    public abstract Set<SocketAddress> getRemoteAddresses(Association p0) throws IOException;
    
    public abstract SctpMultiChannel shutdown(Association p0) throws IOException;
    
    public abstract <T> T getOption(SctpSocketOption<T> p0, Association p1) throws IOException;
    
    public abstract <T> SctpMultiChannel setOption(SctpSocketOption<T> p0, T p1, Association p2) throws IOException;
    
    public abstract Set<SctpSocketOption<?>> supportedOptions();
    
    @Override
    public final int validOps() {
        return 5;
    }
    
    public abstract <T> MessageInfo receive(ByteBuffer p0, T p1, NotificationHandler<T> p2) throws IOException;
    
    public abstract int send(ByteBuffer p0, MessageInfo p1) throws IOException;
    
    public abstract SctpChannel branch(Association p0) throws IOException;
}
